import torchvision
import torchvision.transforms as transforms
from torch.utils.data import DataLoader
class GetDataset(object):
    def __init__(self):
        super(GetDataset, self).__init__()
        self.transform = transforms.Compose([transforms.ToTensor()])
        self.trainset = torchvision.datasets.MNIST(root='./data', train=True,
                                      download=True, transform=self.transform)
        self.testset = torchvision.datasets.MNIST(root='./data', train=False,
                                     download=True, transform=self.transform)

    def get_trainloader(self):
        trainloader = DataLoader(self.trainset, batch_size=128, shuffle=True, num_workers=0)
        return trainloader

    def get_testloader(self):
        testloader = DataLoader(self.testset, batch_size=128, shuffle=True, num_workers=0)
        return testloader

    def get_classes(self):
        classes = ('0', '1', '2', '3', '4', '5', '6', '7', '8', '9')
        return classes

    # #batch_size可以决定跑代码的速度（需根据内存情况来定，<90%)