import torch
from dataset import GetDataset
from create_model import net, optimizer, criterion

getdataset = GetDataset()
trainset = getdataset.trainset
testset = getdataset.testset
trainloader = getdataset.get_trainloader()
testloader = getdataset.get_testloader()
classes = getdataset.get_classes()

for epoch in range(50):  # epoch大小可以观察大致多少次后损失、精度趋于稳定（收敛）
    net.train()
    running_train_loss = 0.0
    train_acc = 0.0
    for i, data in enumerate(trainloader, 0):
        inputs, lables = data
        optimizer.zero_grad()
        outputs = net(inputs)
        train_loss = criterion(outputs, lables)
        running_train_loss += train_loss.item()
        pred2 = torch.max(outputs, 1)[1]
        # print(pred2,1)
        # print(lables,2)
        num_correct2 = (pred2 == lables).sum()
        train_acc += num_correct2.item()
        train_loss.backward()
        optimizer.step()
    print('epoch:%d train_loss:%.3f train_acc:%.3f' % (epoch + 1, running_train_loss / len(trainset),
                                                       train_acc / len(trainset)))

    net.eval()  # 处理数据
    running_test_loss = 0.0
    test_acc = 0.0
    class_correct = list(0. for i in range(10))
    class_total = list(0. for i in range(10))
    for i, data in enumerate(testloader, 0):
        inputs, lables = data
        outputs = net(inputs)
        test_loss = criterion(outputs, lables)
        running_test_loss += test_loss.item()
        pred = torch.max(outputs, 1)[1]
        num_correct = (pred == lables).sum()
        c = (pred == lables).squeeze()
        # print(len(c))
        for l in range(len(c)):
            label = lables[l]
            class_correct[label] += c[l].item()
            class_total[label] += 1
        test_acc += num_correct.item()
        test_loss.backward()
        optimizer.step()
    print('epoch:%d test_loss:%.3f test_acc:%.3f' % (epoch + 1, running_test_loss
                                                     / len(testset), test_acc / len(testset)))
    for i in range(10):
        print('Accuracy of %5s:%2d %%' % (classes[i], 100 * class_correct[i] / class_total[i]))




